package javafx3deffect;

import javafx.scene.paint.*;
import javafx.application.*;
import javafx.scene.effect.*;
import javafx.scene.geometry.*;
import javafx.application.Stage;
import javafx.scene.geometry.Circle;
import javafx.scene.paint.Color;
import javafx.animation.Timeline;
import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.ext.swing.Button;
import javafx.input.MouseEvent;
import javafx.scene.text.Text;
import javafx.scene.Font;
import javafx.scene.FontStyle;

/**
*  @author Amit
*/
var val:Integer;
var t=Timeline {
    repeatCount: Timeline.INDEFINITE
    autoReverse:true
    keyFrames : [
        KeyFrame {
            time : 0s
            values:val=>0
         },KeyFrame {
            time : 4s
            values:val=>400 tween Interpolator.EASEBOTH
         }
    ]
}
Frame {
    title: "Painting Variations"
    width: 500
    height: 400
    closeAction: function() { 
        java.lang.System.exit( 0 ); 
    }
    visible: true
    stage: Stage {
        content: [
              Text {
                font: Font { 
                    size: 24 
                    style: FontStyle.PLAIN
                }
                x: 0, y: 20
                content: "HelloWorld"
                effect:GaussianBlur{radius:10}
                scaleX:3.4
                scaleY:3.4
               },
              Circle {
                centerX: bind val, centerY: 40
                radius: 60
                opacity:0.6
                fill: RadialGradient{
                    centerX:30
                    centerY:10
                    radius:30
                    proportional:false
                    stops:[
                        Stop {offset: 0.3 color: Color.GREEN},
                        Stop {offset: 1.0 color:Color.DARKGREEN }
                    ]
                }
                onMouseMoved: function( e: MouseEvent ):Void {
                    t.start();
                }
            },Text {
                font: Font { 
                    size: 24 
                    style: FontStyle.PLAIN
                }
                x: 10, y: 30
                content: "HelloWorld"
                fill:RadialGradient{
                    centerX:60
                    centerY:30
                    radius:60
                    proportional:false
                    stops:[
                        Stop {offset: 0.3 color: Color.GREEN},
                        Stop {offset: 1.0 color:Color.LIGHTGREEN }
                    ]
                }
                scaleX:3
                scaleY:3
            }
        ]

    }
}
